//Es3.6
#include <stdio.h>

#define MAX_LEN_STRING 100
#define MAX_LEN_TEL 11
#define CONT_MAX 1
#define MAX_ETA_LEN 3

/*--------------------------------------------------------------------------*/
/*                        Funzioni già implementate                         */
/*--------------------------------------------------------------------------*/

int str_len(char stringa[]){
	int len;

	for(len=0; stringa[len]!='\0'; len++);

	return len;
}

int string_cmp(char stringa1[], char stringa2[]){
	
	int i;

	// Lunghezza stringhe
	int len1, len2, len_max;

	len1 = str_len(stringa1);
	
	len2 = str_len(stringa2);	

	// Minore in lunghezza
	if (len1 < len2) {
		return -1;
	} else if (len2 < len1) {
		return 1;
	}
	
	// Minore alfabeticamente
	for(i=0; i<len1; i++) {
		if(stringa1[i] < stringa2[i])
			return -1;
		if(stringa1[i] > stringa2[i])
			return 1;
	}

	return 0;
}

int getint(void){
	char input;
	int num = 0;
	
	// Prendo il primo carattere
	input = getchar();
	// Ad ogni ciclo converto il singolo carattere in cifra numerica
	while(input!='\n'){
		// Rimuovo l'offset del carattere ASCII '0' (=48)
		input = input - '0';
		// Sposto le cifre già inserite nelle posizioni più significative
		num = 10*num + input;
		// Ricevo il nuovo carattere
		input = getchar();	
	}
	return num;
}

// Scrive a schermo un intero
// num: numero da stampare
// Ritorna 0 se tutto ok
int putint(int num) {
	char output[MAX_ETA_LEN] = "";

	int i = 0;
	int j;

	int rem;

	// Gestisco il caso num == 0 separatamente
	if (num == 0) {
        	output[i] = '0';
		i++;
        	output[i] = '\0';
    	} else { 
		// Gestisco cifra per cifra
		while(num != 0){
			// Calcolo il resto per la base 10
			rem = num % 10;
			// Aggiungo l'offset del carattere ASCII '0' (=48)
			output[i] = rem + '0';
			// Passo al carattere successivo
			i++;
			// Divido per 10 il numero per considerare la cifra successiva
			num = num/10;
		// Al termine aggiungo il terminatore
		output[i] = '\0';
		}
	
	}
	// Stampo invertita
	for(j=i; j>-1; j--){
		putchar(output[j]);
	}

	return num;	
}

void putstring(char stringa[]){
	int j;	
	
	for(j=0; j<str_len(stringa); j++){
		putchar(stringa[j]);
	}
	
}

/*--------------------------------------------------------------------------*/
/*                        Funzioni da implementare                          */
/*--------------------------------------------------------------------------*/

// Definizione del tipo contatto
typedef struct{
	char cognome[MAX_LEN_STRING];
	char nome[MAX_LEN_STRING];
	int eta;
	char numero_tel[MAX_LEN_TEL];
}contatto;

// La nostra rubrica (vettore di strutture)
contatto rubrica[CONT_MAX];

// Funzione per gestire l'inserimento di un contatto
// Ritorna un nuovo contatto completo
contatto inserisci_contatto(void){
	contatto nuovo_contatto;

	char input;

	int j;

	// Inserimento del cognome
	putstring("Inserisci cognome ");
	j = 0;
	while(input !='\n'){// || j < MAX_LEN_STRING){
		input = getchar();
		nuovo_contatto.cognome[j] = input;
		j++;
	}
	j--;
	nuovo_contatto.cognome[j] = '\0';
	input = ' ';
	// Inserimento del nome
	putstring("Inserisci nome ");
	j = 0;
	while(input !='\n'){// || j < MAX_LEN_STRING){
		input = getchar();
		nuovo_contatto.nome[j] = input;
		j++;
	}
	j--;
	nuovo_contatto.nome[j] = '\0';
	input = ' ';
	// Inserimento età
	putstring("Inserisci età ");
	nuovo_contatto.eta = getint();
	// Inserimento numero telefono
	putstring("Inserisci numero ");
	for(j=0; j < MAX_LEN_TEL - 1; j++){
		nuovo_contatto.numero_tel[j] = getchar();
	}
	nuovo_contatto.numero_tel[j] = '\0';

	fflush(stdin);
	
	// Ritorno il nuovo contatto
	return nuovo_contatto;
}

// Funzione per stampare i contatti
// rubrica: vettore contentente i contatti da stampare
void stampa_contatto(contatto contatto){
	int j;
	
	// Stampo il cognome
	putstring(contatto.cognome);
	putchar(' ');
	// Stampo il nome
	putstring(contatto.nome);
	putchar(':');
	// Stampo l'età
	putint(contatto.eta);
	putchar(' ');
	// Stampo il numero di telefono
	putstring(contatto.numero_tel);
	putchar('\n');
}

// Funzione per ricercare un contatto
// rubrica: vettore contenente i contatti in cui ricercare
void ricerca_contatto(void){
	char cognome_contatto[MAX_LEN_STRING] = "pippo";
	char input = ' ';
	int j = 0;
/*
	// Inserimento del cognome da ricercare
	while(input !='\n'){// || j < MAX_LEN_STRING){
		input = getchar();
		cognome_contatto[j] = input;
		j++;
	}
	j--;
	cognome_contatto[j] = '\0';
*/	
	int i;
	for(i=0; i<CONT_MAX; i++){
		if(string_cmp(rubrica[i].cognome, cognome_contatto) == 0){
			stampa_contatto(rubrica[i]);
		}
	}
}

int main(){
	
	int i;

	/* Inserimento contatti */
	for(i=0; i<CONT_MAX; i++){
		// Aggiungo il contatto alla rubrica
		rubrica[i] = inserisci_contatto();
	}

	/* Stampa contatti */
	for(i=0; i<CONT_MAX; i++){
		stampa_contatto(rubrica[i]);
	}

	ricerca_contatto();

	return 0;
}
